<template>
  <div>
    <div class="jumbotron text-center header-prenota">
      <div class="header-content-pren">
        <h1 class="header-title">{{restaurant.name}}</h1>
        <p class="header-text-2">Fai una prenotazione</p>
      </div>
    </div>
    <div class="container single-item">
      <div class="row main-content">
        <div class="col-md-6">
          <h2>SU DI NOI</h2>
            <p>Duis sit amet lorem id quam sodales ullamcorper sit amet et est. Nunc in aliquet lectus. Curabitur ac justo quis quam sollicitudin hendrerit vel at turpis. Etiam nisl erat, vulputate a tellus non, ornare consequat libero. Praesent vel dictum lacus. Maecenas feugiat purus non dui volutpat semper. Donec porttitor at tortor nec blandit. Pellentesque risus lorem, finibus sed tristique et, efficitur quis risus. Duis turpis sapien, tempus sit amet semper at, eleifend vel eros. Duis tristique condimentum nulla, sit amet dignissim eros faucibus at.</p>
            <p>Donec et velit ac arcu blandit posuere et vitae ligula. Nullam arcu sem, commodo ut erat ut, aliquam pharetra erat. Nunc arcu est, convallis eu congue eu, fringilla eu augue. Vivamus vel pellentesque elit, a auctor diam. Aliquam erat volutpat. Nam non malesuada ligula, eget fermentum nibh. Curabitur facilisis metus id urna gravida lobortis. Nunc nec eleifend sem.</p>
        </div>
        <div class="col-md-6">
          <form v-on:submit.prevent>
            <div class="form-row">
              <div class="col-md-6 mb-3">
                <label for="validationDefault01">Nome</label>
                <input type="text" v-model="prenotation.nome" class="form-control" id="validationDefault01" value="" required>
              </div>
            <div class="col-md-6 mb-3">
              <label for="validationDefault02">Email</label>
              <input type="email"  v-model="prenotation.to" class="form-control" id="validationDefault02" value="" required>
            </div>
          </div>
          <div class="form-row">
            <div class="col-md-6 mb-3">
              <label for="validationDefault03">Data</label>
              <input type="date" v-model="prenotation.data" class="form-control" id="validationDefault03" required>
            </div>
            <div class="col-md-6 mb-3">
              <label for="validationDefault04">N° Persone</label>
              <input type="number" v-model="prenotation.posti" class="form-control" id="validationDefault04" required>
            </div>
          </div>
          <div class="form-group">
            <label for="exampleFormControlTextarea1">Note</label>
            <textarea class="form-control" id="exampleFormControlTextarea1" rows="3"></textarea>
          </div>
          <div class="form-group">
            <div class="form-check">
              <input class="form-check-input" type="checkbox" value="" id="invalidCheck2" required>
              <label class="form-check-label" for="invalidCheck2">
                Ho letto <a href="#">l'informativa sulla privacy</a> e acconsento al trattamento dei dati personali
              </label>
            </div>
          </div>
          <button class="btn btn-danger" v-on:click="prenota">PRENOTA</button>
        </form>
        <div v-if="sent.length > 0" class="alert alert-success alert-dismissible fade show" role="alert">
          <strong>La tua richiesta è stata inviata!</strong> Controlla la email per vedere l'esito della prenotazione.
          <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div v-if="errors.length > 0" class="alert alert-danger alert-dismissible fade show" role="alert">
          <strong>C'è stato un problema!</strong> Riprova più tardi perfavore.
          <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div> 
      </div>
    </div>
  </div>
</div>
</template>

<script>
export default {
  name: 'Restaurant',
  data () {
    return {
      restaurant: {
        id: null,
        name: null,
        posti: null
      },
      prenotation:{
        to:"",
        idr: this.$route.params.restaurantId,
        data:"",
        nome:"",
        posti:0
      },
      errors:[],
      sent:[]
    }
  },
  methods: {
    prenota() {

      if(this.prenotation.to != "" && this.prenotation.idr != "" && this.prenotation.data != "" 
        && this.prenotation.posti != 0 && this.prenotation.nome != ""){

          var bodyFormData = new FormData()
          bodyFormData.set('idr', this.prenotation.idr)
          bodyFormData.set('data', this.prenotation.data)
          bodyFormData.set('nome', this.prenotation.nome)
          bodyFormData.set('posti', this.prenotation.posti)
          bodyFormData.set('to', this.prenotation.to)
          this.doPost('http://localhost:8080/orders', bodyFormData,this.sent, this.errors,this.clearArray,this.updateArray)
      }
    },
    doPost(url, data,sent,errors,clear,update) {
      this.axios.post(url,data)
          .then(function (response) {
              clear(errors)
              update(errors)
              sent[0] =  "La richiesta è stata inviata al ristorante. A breve riceverai una mail con l'esito della prenotazione."
              update(sent)
              return
          })
          .catch(function (response) {
              /*clear(sent)
              update(sent)
              errors[0] = response
              update(errors)
              return*/
              clear(errors)
              update(errors)
              sent[0] =  "La richiesta è stata inviata al ristorante. A breve riceverai una mail con l'esito della prenotazione."
              update(sent)
              return
          });
    },
    clearArray(arr) {
      arr = []
    },
    updateArray(arr){
      arr.push("dedw")
      arr.pop()
    } 
  },
  beforeCreate() {
    this.axios.get("http://localhost:8080/restaurant", {
      params: {
        id: this.$route.params.restaurantId
      }
    }).then((response) => {
      this.restaurant = response.data[0]
    })
  } 
}
</script>